#!/usr/local/bin/perl

#=============================================================================#
# oCiJbg : Binary Cut (bin_cut.pl)                                    #
#                                                                             #
# oCit@Cw肳ꂽ͈͂𔲂oĕʃt@CƂďo͂      #
#                                                                             #
# Edited by tazawa                                                            #
#                                                                             #
# 2002.10.11 - Ver 0.1   : Ƃ肠쐬                                     #
#=============================================================================#

#-----------------------------------------------------------------------------#
# ݒ荀                                                                    #
#-----------------------------------------------------------------------------#
my $src = "";  # ftHg̏t@C

#-----------------------------------------------------------------------------#
# O[o錾                                                              #
#-----------------------------------------------------------------------------#
# W[
use strict;  # ϐ錾̋

#-----------------------------------------------------------------------------#
# C                                                                  #
#-----------------------------------------------------------------------------#
if((@ARGV) != 3)
{
	die 'usage : perl bin_cut.pl <target-file> <start-adrs> <end-adrs|offset>';
}

open(SRC, $ARGV[0]) or die "Can't Open $ARGV[0]. Because $!";
binmode(SRC);

my $size = -s $ARGV[0];
my $start_adrs = $ARGV[1];
$start_adrs = hex($start_adrs) if($start_adrs =~ /^0x/);

die "Bad Start-Address: $ARGV[1]" if($start_adrs < 0 or $start_adrs > $size);

seek(SRC, $start_adrs, 0);

my $end_adrs = $ARGV[2];

if($end_adrs =~ /^\+/)  # ItZbgwȂ
{
	$end_adrs =~ s/^+//;
	$end_adrs = hex($end_adrs) if($end_adrs =~ /^0x/);
}
else
{
	$end_adrs = hex($end_adrs) if($end_adrs =~ /^0x/);
	$end_adrs -= $start_adrs;  # ItZbglɂ
}

die "Bad End-Address: $ARGV[2]" if($end_adrs < 0 or $end_adrs > $size);

my $dest = $start_adrs . "+" . $end_adrs . '.bin';

open(DEST, ">$dest");
binmode(DEST);

read(SRC, my $tmp, $end_adrs);
print DEST $tmp;

# for DEBUG
print STDOUT $start_adrs . $end_adrs . $tmp;

close(SRC);
close(DEST);

